package lib.persistence;

import lib.exceptions.PersistenceMechanismException;
import lib.exceptions.TransactionException;

import healthwatcher.aspects.persistence.annotations.*;

public interface IPersistenceMechanism {

	public void connect() throws PersistenceMechanismException;

	public void disconnect() throws PersistenceMechanismException;

	public Object getCommunicationChannel() throws PersistenceMechanismException;

	public void releaseCommunicationChannel() throws PersistenceMechanismException;
	
	@TransactionExEvent
	public void beginTransaction() throws TransactionException;

	@TransactionExEvent
	public void commitTransaction() throws TransactionException;

	@TransactionExEvent
	public void rollbackTransaction() throws TransactionException;
}
